package es.autentia.spring.controller;

import java.util.*;
import java.util.stream.*;

import org.springframework.beans.factory.annotation.*;
import org.springframework.web.bind.annotation.*;

import es.autentia.spring.model.*;
import es.autentia.spring.service.*;
import es.autentia.spring.util.*;

@RestController
@RequestMapping(value = "/team")
public class TeamController {

    private static final String COUNTRY = "country";

    private final TeamService teamService;

    private final Map<String, Country> mapLeagues;

    @Autowired
    public TeamController(TeamService teamService) {
        this.teamService = teamService;
        this.mapLeagues = Stream.of(Country.values()).collect(Collectors.toMap(Country::getCode, item -> item));
    }

    @RequestMapping(method = RequestMethod.GET)
    public List<Team> getTeams(@RequestParam(required = false, value = COUNTRY) String code) {
        CountryDbContextHolder.setDbType(mapLeagues.get(code.toUpperCase()));
        return teamService.getTeams();
    }

}
