package es.autentia.spring.model;

import org.apache.commons.lang3.builder.*;

public class Team {

    private final Integer id;

    private final String name;

    public Team(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    @Override
    public int hashCode() {
        final HashCodeBuilder hashCodeBuilder = new HashCodeBuilder();
        hashCodeBuilder.append(id);
        hashCodeBuilder.append(name);
        return hashCodeBuilder.toHashCode();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Team) {
            final Team param = (Team)obj;
            final EqualsBuilder equalsBuilder = new EqualsBuilder();
            equalsBuilder.append(this.id, param.id);
            return equalsBuilder.isEquals();
        }
        return false;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.reflectionToString(this);
    }
}
