package es.autentia.spring.contoller;

import static org.hamcrest.Matchers.*;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;

import java.util.*;

import org.junit.*;

import es.autentia.spring.controller.*;
import es.autentia.spring.model.*;
import es.autentia.spring.service.*;
import es.autentia.spring.util.*;

public class TeamControllerTest {

    final TeamService teamService = mock(TeamService.class);

    final TeamController teamController = new TeamController(teamService);

    final List<Team> teams = Arrays.asList(mock(Team.class));

    @Test
    public void shouldReturnTeamsSpanish() throws Exception {

        when(teamService.getTeams()).thenReturn(teams);

        final List<Team> result = teamController.getTeams(Country.SPAIN.getCode());

        assertThat(result, is(teams));
        assertThat(CountryDbContextHolder.getDbType(), is(Country.SPAIN));
    }

    @Test
    public void shouldReturnTeamsEnglish() throws Exception {

        when(teamService.getTeams()).thenReturn(teams);

        final List<Team> result = teamController.getTeams(Country.GERMANY.getCode());

        assertThat(result, is(teams));
        assertThat(CountryDbContextHolder.getDbType(), is(Country.GERMANY));
    }
}
