package es.autentia.spring.util;

import static org.hamcrest.Matchers.*;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;

import java.sql.*;
import java.util.*;

import javax.sql.*;

import org.junit.*;

import es.autentia.spring.model.*;

public class CountryRoutingDataSourceTest {

    final DataSource dataSource = mock(DataSource.class);

    final Map<Object, Object> targetDataSources = new HashMap<>();

    final CountryRoutingDatasource leagueRoutingDatasource = new CountryRoutingDatasource();

    @Before
    public void init() throws SQLException {
        targetDataSources.put(Country.SPAIN, dataSource);
        leagueRoutingDatasource.setTargetDataSources(targetDataSources);
        leagueRoutingDatasource.afterPropertiesSet();
        doReturn(mock(Connection.class)).when(dataSource).getConnection();
    }

    @Test
    public void shouldReturnConnection() throws Exception {

        CountryDbContextHolder.setDbType(Country.SPAIN);

        assertThat(leagueRoutingDatasource.getConnection(), is(notNullValue()));

        verify(dataSource).getConnection();
    }

}
